/*
 * restart.c
 *
 * $Id: restart.c,v 1.6 2001/09/16 22:45:06 asuffield Exp $
 */
#include "restart.h"
#include "common.h"
#include "ircd.h"
#include "send.h"
#include "struct.h"
#include "s_debug.h"
#include "s_log.h"
#include "client.h"
#include "umodes.h"
#include "paths.h"
#include "modules.h"

#include <unistd.h>
#include <stdlib.h>

/* external var */
extern char **myargv;

void
restart(char *mesg)
{
  static int was_here = 0;	/* redundant due to restarting flag below */

  if (was_here)
    abort();
  was_here = 1;

  log(L_NOTICE, "Restarting Server because: %s, memory data limit: %d",
      mesg, get_maxrss());

  server_reboot();
}

void
server_reboot(void)
{
  int i;

  sendto_ops_flag(UMODE_SERVNOTICE,
		  "Aieeeee!!!  Restarting server... memory: %d",
		  get_maxrss());

  log(L_NOTICE, "Restarting server...");
  flush_connections(0);
#ifdef SAVE_MAXCLIENT
  write_stats();
#endif

  modules_deinit();

  for (i = 0; i < MAXCONNECTIONS; ++i)
    close(i);
  execv(my_binary, myargv);

  exit(-1);
}
